/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package mime

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Media struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	AutoOpen *dbusPropertyMediaAutoOpen
}

func (obj *Media) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Media) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyMedia(obj *Media) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.api.Media',sender='" + obj.DestName + "',member='PropertiesChanged'")

	obj.AutoOpen.Reset()
}

func (obj *Media) EnableAutoOpen(arg0 bool) (_err error) {
	_err = obj.core.Call("com.deepin.api.Media.EnableAutoOpen", 0, arg0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Media) GetDefaultApp(arg0 string) (arg1 string, _err error) {
	_err = obj.core.Call("com.deepin.api.Media.GetDefaultApp", 0, arg0).Store(&arg1)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Media) ListApps(arg0 string) (arg1 string, _err error) {
	_err = obj.core.Call("com.deepin.api.Media.ListApps", 0, arg0).Store(&arg1)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Media) Reset() (_err error) {
	_err = obj.core.Call("com.deepin.api.Media.Reset", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Media) SetDefaultApp(arg0 string, arg1 string) (_err error) {
	_err = obj.core.Call("com.deepin.api.Media.SetDefaultApp", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

type dbusPropertyMediaAutoOpen struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyMediaAutoOpen) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.api.Media.AutoOpen is not writable")
}

func (this *dbusPropertyMediaAutoOpen) Get() bool {
	v, _ := this.GetValue()
	return v.(bool)
}
func (this *dbusPropertyMediaAutoOpen) GetValue() (interface{} /*bool*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.api.Media", "AutoOpen").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool), nil
	}
	return *new(bool), err
}
func (this *dbusPropertyMediaAutoOpen) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewMedia(destName string, path dbus.ObjectPath) (*Media, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Media{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.AutoOpen = &dbusPropertyMediaAutoOpen{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.DBus.Properties',sender='" + destName + "',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='" + string(path) + "',interface='com.deepin.api.Media',sender='" + destName + "',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.api.Media" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "AutoOpen" {
						obj.AutoOpen.Notify()
					}
				}
			} else if v.Name == "com.deepin.api.Media.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "AutoOpen" {
						obj.AutoOpen.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *Media) { DestroyMedia(_obj) })
	return obj, nil
}
