/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package server

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type RemotingServer struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	GetStatus_ *dbusPropertyRemotingServerGetStatus_
	GetPeerId_ *dbusPropertyRemotingServerGetPeerId_
}

func (obj *RemotingServer) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *RemotingServer) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyRemotingServer(obj *RemotingServer) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.Remoting.Server',sender='" + obj.DestName + "',member='PropertiesChanged'")

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.Remoting.Server',sender='" + obj.DestName + "',member='StatusChanged'")

	obj.GetStatus_.Reset()
	obj.GetPeerId_.Reset()
}

func (obj *RemotingServer) Start() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Server.Start", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingServer) Stop() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Server.Stop", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingServer) StopNotify() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Server.StopNotify", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingServer) GetPeerId() (arg0 string, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Server.GetPeerId", 0).Store(&arg0)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingServer) GetStatus() (arg0 int32, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Server.GetStatus", 0).Store(&arg0)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingServer) ConnectStatusChanged(callback func(status int32)) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.daemon.Remoting.Server.StatusChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*int32)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(int32))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyRemotingServerGetStatus_ struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyRemotingServerGetStatus_) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Remoting.Server.GetStatus_ is not writable")
}

func (this *dbusPropertyRemotingServerGetStatus_) Get() int32 {
	v, _ := this.GetValue()
	return v.(int32)
}
func (this *dbusPropertyRemotingServerGetStatus_) GetValue() (interface{} /*int32*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Remoting.Server", "GetStatus_").Store(&r)
	if err == nil && r.Signature().String() == "i" {
		return r.Value().(int32), nil
	}
	return *new(int32), err
}
func (this *dbusPropertyRemotingServerGetStatus_) GetType() reflect.Type {
	return reflect.TypeOf((*int32)(nil)).Elem()
}

type dbusPropertyRemotingServerGetPeerId_ struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyRemotingServerGetPeerId_) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Remoting.Server.GetPeerId_ is not writable")
}

func (this *dbusPropertyRemotingServerGetPeerId_) Get() string {
	v, _ := this.GetValue()
	return v.(string)
}
func (this *dbusPropertyRemotingServerGetPeerId_) GetValue() (interface{} /*string*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Remoting.Server", "GetPeerId_").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string), nil
	}
	return *new(string), err
}
func (this *dbusPropertyRemotingServerGetPeerId_) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

func NewRemotingServer(destName string, path dbus.ObjectPath) (*RemotingServer, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &RemotingServer{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.GetStatus_ = &dbusPropertyRemotingServerGetStatus_{&property.BaseObserver{}, core}
	obj.GetPeerId_ = &dbusPropertyRemotingServerGetPeerId_{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.DBus.Properties',sender='" + destName + "',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='" + string(path) + "',interface='com.deepin.daemon.Remoting.Server',sender='" + destName + "',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.daemon.Remoting.Server" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "GetStatus_" {
						obj.GetStatus_.Notify()

					} else if key == "GetPeerId_" {
						obj.GetPeerId_.Notify()
					}
				}
			} else if v.Name == "com.deepin.daemon.Remoting.Server.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "GetStatus_" {
						obj.GetStatus_.Notify()

					} else if key == "GetPeerId_" {
						obj.GetPeerId_.Notify()
					}
				}
			}
		}
	}()

	dbusAddMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.Remoting.Server',sender='" + obj.DestName + "',member='StatusChanged'")

	runtime.SetFinalizer(obj, func(_obj *RemotingServer) { DestroyRemotingServer(_obj) })
	return obj, nil
}
