/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package sessionwatcher

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type SessionWatcher struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	IsActive *dbusPropertySessionWatcherIsActive
}

func (obj *SessionWatcher) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *SessionWatcher) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroySessionWatcher(obj *SessionWatcher) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.SessionWatcher',sender='" + obj.DestName + "',member='PropertiesChanged'")

	obj.IsActive.Reset()
}

type dbusPropertySessionWatcherIsActive struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertySessionWatcherIsActive) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.SessionWatcher.IsActive is not writable")
}

func (this *dbusPropertySessionWatcherIsActive) Get() bool {
	v, _ := this.GetValue()
	return v.(bool)
}
func (this *dbusPropertySessionWatcherIsActive) GetValue() (interface{} /*bool*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.SessionWatcher", "IsActive").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool), nil
	}
	return *new(bool), err
}
func (this *dbusPropertySessionWatcherIsActive) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewSessionWatcher(destName string, path dbus.ObjectPath) (*SessionWatcher, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &SessionWatcher{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.IsActive = &dbusPropertySessionWatcherIsActive{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.DBus.Properties',sender='" + destName + "',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='" + string(path) + "',interface='com.deepin.daemon.SessionWatcher',sender='" + destName + "',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.daemon.SessionWatcher" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "IsActive" {
						obj.IsActive.Notify()
					}
				}
			} else if v.Name == "com.deepin.daemon.SessionWatcher.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "IsActive" {
						obj.IsActive.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *SessionWatcher) { DestroySessionWatcher(_obj) })
	return obj, nil
}
