/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package sessionmanager

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type XSettings struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	PropList *dbusPropertyXSettingsPropList
}

func (obj *XSettings) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *XSettings) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyXSettings(obj *XSettings) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.XSettings',sender='" + obj.DestName + "',member='PropertiesChanged'")

	obj.PropList.Reset()
}

func (obj *XSettings) GetColor(arg0 string) (arg1 []uint8, arg2 bool, _err error) {
	_err = obj.core.Call("com.deepin.XSettings.GetColor", 0, arg0).Store(&arg1, &arg2)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *XSettings) GetInteger(arg0 string) (arg1 uint32, arg2 bool, _err error) {
	_err = obj.core.Call("com.deepin.XSettings.GetInteger", 0, arg0).Store(&arg1, &arg2)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *XSettings) GetString(arg0 string) (arg1 string, arg2 bool, _err error) {
	_err = obj.core.Call("com.deepin.XSettings.GetString", 0, arg0).Store(&arg1, &arg2)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *XSettings) SetColor(arg0 string, arg1 []uint8) (_err error) {
	_err = obj.core.Call("com.deepin.XSettings.SetColor", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *XSettings) SetInteger(arg0 string, arg1 uint32) (_err error) {
	_err = obj.core.Call("com.deepin.XSettings.SetInteger", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *XSettings) SetString(arg0 string, arg1 string) (_err error) {
	_err = obj.core.Call("com.deepin.XSettings.SetString", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

type dbusPropertyXSettingsPropList struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyXSettingsPropList) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.XSettings.PropList is not writable")
}

func (this *dbusPropertyXSettingsPropList) Get() []string {
	v, _ := this.GetValue()
	return v.([]string)
}
func (this *dbusPropertyXSettingsPropList) GetValue() (interface{} /*[]string*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.XSettings", "PropList").Store(&r)
	if err == nil && r.Signature().String() == "as" {
		return r.Value().([]string), nil
	}
	return *new([]string), err
}
func (this *dbusPropertyXSettingsPropList) GetType() reflect.Type {
	return reflect.TypeOf((*[]string)(nil)).Elem()
}

func NewXSettings(destName string, path dbus.ObjectPath) (*XSettings, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &XSettings{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.PropList = &dbusPropertyXSettingsPropList{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.DBus.Properties',sender='" + destName + "',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='" + string(path) + "',interface='com.deepin.XSettings',sender='" + destName + "',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.XSettings" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "PropList" {
						obj.PropList.Notify()
					}
				}
			} else if v.Name == "com.deepin.XSettings.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "PropList" {
						obj.PropList.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *XSettings) { DestroyXSettings(_obj) })
	return obj, nil
}
